diff a/src/hotspot/share/oops/arrayKlass.cpp b/src/hotspot/share/oops/arrayKlass.cpp
--- a/src/hotspot/share/oops/arrayKlass.cpp
+++ b/src/hotspot/share/oops/arrayKlass.cpp
@@ -298,5 +298,13 @@
 void ArrayKlass::oop_verify_on(oop obj, outputStream* st) {
   guarantee(obj->is_array(), "must be array");
   arrayOop a = arrayOop(obj);
   guarantee(a->length() >= 0, "array with negative length?");
 }
+
+int ArrayKlass::hash_offset_in_bytes(oop obj, markWord m) const {
+  assert(UseCompactObjectHeaders, "only with compact i-hash");
+  arrayOop ary = arrayOop(obj);
+  BasicType type = element_type();
+  int length = LP64_ONLY(m.array_length()) NOT_LP64(ary->length());
+  return ary->base_offset_in_bytes(type) + (length << log2_element_size());
+}
